Whyteboard 0.41.1 - A simple image, PDF and postscript file annotator
https://launchpad.net/whyteboard -- http://code.google.com/p/whyteboard/
Fri 17 September 2010

---- VERSION HISTORY ----

----------------------------------------------------------------------

17 September 2010 - 0.41.1

* New icon
* Windows Vista and 7 - icon now shown in Explorer and the taskbar
* New About Dialog for Windows: looks like GTK, and less crappy than before
* Program translated into Portuguese, latest translations applied.
* PDF Cache viewer's width increased; delete key also removes the selected item

* Bugfix: close button on a sheet allowing the first sheet to be closed,
  causing crashes
* Bugfix with closing the "import image" dialog

* Bugfix: unicode error on loading a file from the operating system "explorer"
* Bugfix: crash when pressing "okay" in Preferences dialog after changing number
  of closed sheets to remember
  Bugfix: misc. items not being translated: ok/cancel buttons, text in colour,
  save and font dialogs
* Bugfix: file types in the "open" dialog not being translated
* Bugfix: languages in the preference dialog not being translated

----------------------------------------------------------------------

30 August 2010 -- 0.41

* "Recent Files" list under the File menu is synchronised across all Whyteboard
  instances
* Improved program updating; removed a dependency on an external library
* Fixed possible Unicode errors on any saving operation to a filepath containing
  unicode characters >255 (e.g. ø)

* Program language defaults to the system language if possible
* Change Foreground / Background options added to Shapes menu and to a shape's
  right-click pop-up menu. Background's changeable when shape is not transparent

* Removed code that was handling loading older .wtbd save files from around a
  year back, as it's no longer needed
* Removed version number from application title (see About Dialog for it)
* Little "*" shown in program title when application has unsaved data
* Removed shortcut key information from popup menus
* Shape viewer dialog handles delete key.
* Deleting shape from shape viewer selects the previous shape; not the first
  shape in the list.
* Removed "focus" rectangle from the currently selected Tab

* Bugfix: possible permission error on Linux when saving a file
* Bugfix - trying to load a file that's been deleted from the Recent Files list
  didn't save the file list, so the file would still be shown
* Fix bug on Mac where wrong version of wxPython was being used
* Fix bug with crash on startup with an older install of wxPython
* Fix bug where program was writing the Language preference as the translated
  language; the program was expecting the language in English

* Bugfix: Using the mouse wheel on the "thickness" selection drop-down with a
  shape selected would create an undo point for each "scroll" of the mousewheel.
  Now it creates an undo point after you have finished scrolling.
* Fix "transparent" checkbox under Shape menu and on the toolbox displaying
  wrong values at times.
* Fix possible "division by zero" bug with Ellipse tool
* Fix tab ordering on many dialogs
* Fix cancelling the Save As dialog in save changes prompt closing the dialog
* Fix the eraser tool appearing as a black square

* Fix undo/redo not making the "sure you want to quit" prompt appear
* Fix preference dialog "view" tab always scrolling to the bottom of the dialog
* Fix bug in opening help files if they had been removed after the program had
  been run
* Fix opening a save file not clearing the undo tab list
* Fix "Delete" in Shape Viewer actually deleting the shape; and not on "okay"

* Fix the selected item being de-selected in the Shape Viewer, and overriding
  any resized columns headers after performing an action
* Fix "Gdk-CRITICAL **: gdk_gc_set_foreground: assertion `color != NULL' failed"
  GTK bug when drawing with a Pen
* Bugfix: Error dialog wouldn't show with unicode characters in "recently saved"
  preference option
* Major changes to the program's file structure. Lots of code cleanup and
  refactorings

----------------------------------------------------------------------

17 May 2010 -- 0.40.1

-- Bugfixes:

* Possible crash with deleting shapes
* Shape Viewer's buttons not being properly disabled on changing sheets
* Opening a .wtbd file from a file explorer wouldn't work
* Windows: function and other shortcut keys not working (e.g. F2/F11/Shift+Tab)
* Windows: Shape Viewer dialog drawing its bitmaps as enabled when they were
  disabled
* Windows: Ctrl+Enter in text input dialog not acting like "okay" button press

----------------------------------------------------------------------

16 May 2010 -- 0.40.0

-- New features/changes:

* New tool: Highlighter. It behaves as the Pen, but draws in a semi-transparent
  ink; perfect for drawing attention to portions of a PDF image

* Image rotation is now performed from a special "handle" for rotating. Rotating
  draws a transparent rectangle "over" the image to show where its rotation will
  end up, instead of drawing the image as it rotates (which was slow)
* Image re-scaling using its selection handles. Also draws a transparent
  rectangle to indicate its new size

* PDF Cache Viewer - view the list of PDF files that Whyteboard is caching. From
  here you can remove cache entries, meaning that the PDF will be re-converted.
* Improvements to rotating an image with the mouse: now "follows" the mouse's
  position, and can be rotated both clockwise and counter-clockwise.
  Thanks to Zack Buhman and members of Stack Overflow for help with the coding
* Scaling of Polygon shapes - increase or decrease their size!

* Rotating Polygon shapes. Note that all scaling/rotating operations are from
  the *center* of the shape
* 8-way selection handle on rectangle, rounded rectangle and ellipse, allowing
  vertical-only / horizontal-only resizing
* Right clicking a shape with the select tool pops up a menu with select/delete/
  edit/move operations. Also, from here, new points may be added to a polygon

* Changing sheets scrolls the new sheet's thumbnail into view
* Few UI changes, program now looks neater with less borders, also takes up less
  vertical space (takes up ~700 pixels vertically at a minimum)
* Removed many Message Boxes, tried to present more helpful error text to the
  user when an error occurs
* Programs remembers last opened file's directory the next time the program runs
* Foreground/background colour swap button added
* "Swap Colours" menu item for when you select a shape that's not transparent

* New toolbar items for Move Shape Up/Down/To Top/To Bottom
* Recently Closed Sheets as a sub-menu to allow you to choose a sheet to re-open
* Improved "save changes?" dialog when you are exiting the program. Now tells
  you how long it was since you last saved, and the buttons have better text
  than "yes/no/cancel"

* Thick rectangles now don't have a "roundness" to their edges
* Help files updated and improved with more detail
* Improved a few icons (circle/ellipse/polygon/rounded rectangle, move up/down
* Little "close" button drawn on the current tab
* Up/down/left/right arrow keys can pan around the canvas.
* The selected shape may be moved around the canvas using the arrow keys too
* Escape key will de-select the currently selected shape (as well as Ctrl-D)
* Cancelling PDF Conversion on Linux takes a few seconds, so the progress bar no
  longer "pumps", and the dialog title changes from "Converting" to "Cancelling"

* The "Shape Viewer" is now in sync with the canvas: adding, deleting, undoing,
  redoing, editing and changing shapes' order is now reflected when the Shape
  Viewer is open
* Minimise button added to the Shape Viewer
* Undo closed tabs remembers the "viewport" of the canvas when closed
* Removed the "Rotate Image" dialog
* Ctrl+Enter in text input dialog will "submit" the text
* Restructured source code directories -- now just run whyteboard.py from the
  main directory to start the program
* Started improving code: removing module dependencies and tight coupling, to
  create more readable/maintainable code.

-- New Preferences / Options:

* Under "View", number of toolbox columns, can be set to 2 or 3 to decrease the
  vertical space used by the toolbox
* Toggle tool preview on/off (to gain more vertical space)
* Toggle colour grid on/off
* "Send Feedback" added to the Help menu
* Command-line extras added (inc. help). Call whyteboard -f FILE to load a file;
  whyteboard -l LANG to set a language e.g. es, spanish, nl, dutch, de, german

-- Bugfixes:

* Important Windows bugfix: drawing a shape would create extra Windows "GDI"
  objects; which was taking up unneeded resources. This bug has been present
  since version 0.25 (3rd release) - released back in January 2009!

* Recently closed tab list was deleting incorrect entries when it had more items
  than the "number of closed tabs" preference
* Bitmap Select could cause some visual anomalies
* Possible crash when loading/saving .wtbd files containing text
* After selecting a shape (and being brought to the front), any shapes that
  were on top of the shape would prevent the user from selecting the handles of
  the selected shape.
* "Recent Files" menu wasn't working on Linux
* Rotated images weren't being saved as rotated
* Shape Viewer's column widths would not take up the full space

* Fixed shape viewer crashing when an item isn't selected
* Using next/previous sheet buttons in the Shape Viewer wouldn't set the
  drop-down control to the changed-to sheet
* "End" key would not jump to the end of the document correctly
* Menu were icons appearing for 3 menu items on Windows when no other menu items
  had icons - now removed
* Stopped a crash when wx.GCDC was not implemented on the system, due to a
  misconfigured wxPython install. Now, the program just doesn't use transparency
  for these users (new highlighter tool is also not available)

* Hopefully stopped a visual oddity/black square appearing underneath the close
  and maximise button on Windows
* Hopefully fixed problem with various "UnicodeError" (the problem doesn't
  happen on my machine, so it's hard to test if the issue is fixed)
* Fixed unit tests so that they at least run -- need to improve the test's code
  coverage, which will come with time.

----------------------------------------------------------------------

31 Dec 2009 -- 0.39.35

* Bugfix: crash with loading fonts saved on Windows into Linux that don't exist
  there on Linux, and vice versa
* Bugfix: bitmap select, and pasting images were broken
* Bugfix: pasting the same image multiple times would create multiple copies of
  the image when saving; now saves one file and refers all copies to that file
* Bugfix: toolbox acting weird when changing between text/icons twice or more
  from the preferences
* Few translation improvements

----------------------------------------------------------------------

28 Dec 2009 -- 0.39.3

* New save format. ".wtbd" files are now renamed ".zip" files. The zip files now
  contain all loaded/imported images (and images from a PDF conversion) to allow
  the save file to be transferred from one computer to another.

  The "old" .wtbd files are also compatible, and will be converted to the new
  format when they are saved with this version of the program. Of course, this
  new change means that the .wtbd files become larger as more images are loaded

  Another downside is there is a performance hit to loading/saving files - I
  haven't benchmarked the difference. It will be more noticeable with saves with
  many open sheets, and with many images.

* Open file dialog defaults to the new "all supported files" rather than .wtbd
  files - so all supported image types, PDF/PS/SVG and .wtbd files are "matched"
* Open file dialog remembers the last opened directory
* Recently opened files sub-menu
* "Reload preferences" added to File menu

* Support for drag and dropping a file onto a Media panel to load it
* Select/deselect and Delete options added to a Note's right-click menu in the
  Note tree
* ImageMagick's location can be set from the preferences
* User's preferences are added to the bug reporter to help debugging
* Many "keyboard accessors" for menu items added where missing
* "Save As" fills in the filename with the current loaded filename
* Latest translations

* Bugfix: exiting the program with multiple Whyteboard instances through "new
  window" would close *all* instances instead of just one
* Bugfix: moving the media panel will maintain a mouse "offset" (not place the
  panel's top-left corner at the mouse position)
* Bugfix: deleting a Note wouldn't remove it from the Note tree
* Bugfix: crash when selecting the "shapes" menu with a Media panel selected
* Bugfix: undoing closed tabs will re-create any Media panels

* Bugfix: possible crash with the clipboard being already open
* Bugfix: possible crash on the "open file" dialog
* Bugfix: Polygon's preview was drawing incorrectly
* Bugfix: image "filter" on open file dialog wouldn't recognise upper case
  files on Linux
* Bugfix: "import image" wouldn't set the correct dialog filter when set to a
  language other than English


----------------------------------------------------------------------

16 Dec 2009 -- 0.39.2

* New Media tool - embed audio and video files into Whyteboard! Each sheet may
  have as many Media panels embedded as you wish
* New Polygon tool - draw a shape with [x] many points, as complex as you wish.
  Each point can then be adjusted separately
* Paste text from the clipboard. Doesn't preserve any font/colour data, though
* Pasted images "into a new sheet" will resize the canvas to the image size
* Support for drag/drop of multiple files; e.g. drag/drop 3 .jpg files will open
  3 new sheets, each containing one of the images
* Support for drag and dropping text. However, dragging text from a web browser
  will not work currently, as it is not recognised as "plain" text

* Stopped a crash when PDF conversion with ImageMagick fails (due to no install
  of GhostScript)
* Saving a new file suggests the current date/time as the filename
* The Arrow tool's arrows are drawn at a smaller degree
* Middle clicking a sheet in the tab list will close it
* A check for a minimum wxPython version of 2.8.9.0
* The uninstaller on Windows will prompt for feedback on why Whyteboard is being
  uninstalled
* Updated help files

* Bugfix: the program's process could sometimes remain after closing the program
* Bugfix: text objects were being re-drawn twice after using the Select tool
* Bugfix: can now drag/drop files onto the canvas once again (0.39.0 broke it)
* Bugfix: Changing background colour with a shape selected would change its
  background colour, even with "transparent" checked
* Bugfix: Exporting as PDF on Linux without typing ".pdf" into the filename now
  works
* Bugfix: Updating the EXE was broken on Windows, now fixed
* Bugfix: ensured some strings were displayed in their translated form
* Bugfix: sheet counts were appearing wrong, sometimes.
* Bugfix: pasting with the menu/toolbar buttons could position the image wrongly
* Bugfix: copying a Bitmap Select "outside" of the canvas could cause a crash
* Fixed a few spelling mistakes
* Latest translations. New translation:
   - Galician

----------------------------------------------------------------------

17 Nov 2009 -- 0.39.1

* Arrow tool
* Bugfix: "cancel" in the "do you want to save before quitting" dialog would
  quit, not cancel the dialog
* Bugfix: keyboard shortcuts for selecting tools were not working on Windows

----------------------------------------------------------------------

16 Nov 2009 -- 0.39.0

* Background colour added - fills in shapes with solid colour. Right click a
  colour in the grid or with the Eyedropper to set that colour as the background
* Checkbox below the colours for transparency - ignores the background colour
* Export as PDF functionality (exports all sheets as images; requires Image
  Magick)
* Import/export Whyteboard preference files
* Bitmap Select now uses a fancy transparent blue fill (default is off - may be
  slow on older machines. Toggle it on in the preferences)

* Drag and drop sheets to reposition them as well as the notes tree / thumbnails
* The currently selected tab is highlighted with the transparent fill
* Move shape up / down / to top / to bottom feature, with keyboard shortcuts
* Shape viewer - see a list of each tab's shapes and their properties, and move
  their drawing order around.


* Bugfix: When resizing the canvas to the right, the cursor was misaligned
* Bugfix: Cancel button for PDF conversion on Windows would take a long time
  to actually cancel, it is now practically instant
* Bugfix: Default font preferences's label was messed up when a default font
  preference was not set (on Windows)
* Bugfix: Some crashes when loading older .wtbd files fixed
* Bugfix / UI: Current shape de-selects with bitmap select / export / print, so
  the handles are never copied/drawn into the PNG/print
* Bugfix: Rotate cursor on Linux looked bad

* Bugfix: Incompatibilities between Windows and Linux saved .wtbd files. Should
  now be able to load files saved on Windows that was saved on Linux; vice versa
* Bugfix: Printout title was aligned too low on the page
* Bugfix: Pasting to a new sheet now places the image at the top-left corner
* Bugfix: Select tool causing "flickering" when deselecting -- I said this was
  fixed last release, but the problem remained. NOTE: Whyteboard will draw the
  most recently drawn shape first. If you draw a rectangle, draw 20 other things
  on top of it, then move the rectangle - the rectangle will still be drawn last
  (and thus, be covered by other shapes if they're on top of it)

* UI: "Apply" buttons placed where appropriate (resize canvas, rotate image)
* UI: Resize Canvas dialog now shows the memory size of the new canvas in MBs
* UI: Keyboard hotkeys for selecting tools - e.g. P for Pen, R for Rectangle.
  See each item's tooltip for specifics
* Hotkeys for navigating the canvas with keyboard: home, end, page up, page down.
  Use to jump to the very left (home) and very right (end) of the canvas. Hold
  Ctrl as you press the keys to jump to the top and bottom of the document.

* UI: Wordwrapped texts that could become too long in different languages
* UI: Repositioned some menu items; new menu category -- Shapes
* UI: Preference to toggle the page title in a printout
* UI: Export sub-menu in File, instead of 3 separate entries
* UI: Escape key closes full screen view
* UI: Black border drawn around thumbnails on Windows, looked weird without

* Latest translations. New language:
   - Arabic

----------------------------------------------------------------------

28 Oct 2009 -- 0.38.8

* Resize canvas through a menu dialog, or by dragging the edges of the canvas
  to resize (like in ms paint). Many thanks to Michael H.
* Support for printing, print preview, page setup
* Rotate an image via its selection handles, or through a dialog

* An error handler, which will gracefully handle any errors, and allow them
  to be submitted to me by loading a simple website
* The toolbox in the left-hand pane can be viewed as images instead of text
  buttons (default: icon view)
* Delete shape functionality (select a shape with Select tool, press Delete), or
  Edit->Delete Shape, or via the new toolbar icon
* Additional preference tab: "View". Moved statusbar/toolbar options here, as
  well as allowing the user to change between text/icon views

* Bugfix: Preferences' "Select Language" list was always shown in English
* Bugfix: Bold headings in "Font/Colour" preferences had a large font in Windows
* Bugfix: Eraser's cursor was offset slightly, and erasing the wrong area
* Bugfix: Pasting now pastes the image under the cursor, not at the top-left
* Bugfix: Translations not loading on all versions!
* Bugfix: Select tool causing "flickering" when deselecting

* More translations; now complete in Russian, Spanish, Italian and Welsh. Over
  85% done in Dutch and German. Thanks to all contributors! New languages:
   - Traditional Chinese
   - Portugese
   - Japanese
   - Russian
   - Hindi

----------------------------------------------------------------------

17 Oct 2009 -- 0.38.5

* Support for internationalization - Whyteboard will be available in other
  languages once translated. Currently (almost) fully translated into:
   - Dutch
   - English
   - Italian
   - Welsh

  and, partially:
   - Czech
   - French
   - German
   - Spanish

* User preferences, allowing customisation of the program:
   - Language
   - Preferred default font
   - Your 9 colours in the left-hand panel
   - PDF conversion quality options (normal/high/highest)
   - How many sheets to remember for "undo closed sheets"
   - Toggle toolbar / statusbar

* Whyteboard remembers your converted PDF files' image locations, so when you
  load that PDF again, it will not need to convert it.
* Export all sheets (as a series of images) functionality
* Cancel button added to the PDF conversion progress bar
* Added right-click pop-up menus to each thumbnail / Note tree item. From here
  you can also rename, close or export that sheet
* User Interface improvements
* Help Files improvements
* Eraser now erases a larger surface
* Shift + Tab / Shift + Ctrl + Tab shortcuts now work on Linux (GTK at least)
* Bugfix: the "Paste" menu was always active, even with nothing to paste (fixed)

----------------------------------------------------------------------

06 Oct 2009 -- 0.38.1

* Emergency Bugfix - closing any sheet would always close the first sheet
* Bugfix - closing the current tab would not remove its Notes from the tree view
* Improvements and fixes to renaming sheets - the note tree item and thumbnail
  text are renamed
* Hopefully (?!) fixed a bug on Windows where the same drawing would appear on
  every sheet
* Moved this file into CHANGELOG.txt, formatted it nicely

----------------------------------------------------------------------

04 Oct 2009 -- 0.38.0

* Select tool: can select shapes to alter their colour/thickness, edit text and
  notes, move shapes and resize them. Selected shapes are drawn with an outline
  "handle" at their corners
    -- Images and text can also be repositioned
    -- can double click text/notes to edit them
    -- moveable shapes are shown by the cursor changing to a hand

* Text input dialogs remembers the last font used, which is selected by default
  when creating new Text/Notes
    -- the chosen font is also saved into the .wtbd save file

* Improved undo/redo to support editing, moving and resizing of objects as
  described above. Text edits can also be undone
* Button to change colour in text input dialog, instead of always drawing with
  the user's chosen palette colour

* Thumbnail label shows the selected thumb label in bold
* The Pen tool now draws in response to a single mouse click; before the mouse
  needed to be moved to draw
* Each sheet can have its own BitmapSelect at anytime. Undoing and redoing will
  not remove the selection; drawing a new shape will
* Help files updated to reflect new changes and clarify any issues before

* Mouse x/y position tracked in the status bar
* Over 10 bug fixes
* Misc existing code improvements and performance increases
* More/better unit testing to help with adding new features, tracking down
  potential bugs and increased code confidence


----------------------------------------------------------------------

06 May 2009 -- 0.37.0

* 'Check for Updates'- Whyteboard can update itself
    -- will download an .exe / .tar.gz as appropriate
    -- on Windows, running via source will download the tar, which is cool
       because Windows doesn't support .tar.gz by default
    -- shows progress of downloaded file
    - program restarts with new version loaded, also re-loads the current .wtbd

* HTML Help system/manual built into the application
    -- well, via a folder containing HTML help files
    -- if they are not present, they can be downloaded (optional)

* 'About Box' standardised
* Exit dialog more like other apps: "sure you want to save?" (yes/no/cancel),
  instead of "sure you want to quit?" (yes/no)
     -- also asks when opening a new .wtbd file with an unsaved .wtbd file open
     -- and after downloading the update, before the program restarts it will
        prompt for save: yes/no

----------------------------------------------------------------------

20 Apr 2009 -- 0.36.7

* Memory use improved from undo closed sheet improved
* Bugfix: paste / paste as new sheet - not updating the thumbnail
* Backwards/forwards compability: from this version onwards,  Whyteboard will
 not change the version inside saved .wtbd files that are created in a newer
 version of Whyteboard. i.e. version 0.36.7 won't change the version inside a
 file saved in 0.36.9 (before, it would). It will update the version from a file
 saved in < 0.36.7 to 0.36.7

----------------------------------------------------------------------

13 Apr 2009 -- 0.36.6

* Undo closed tabs, last 10 tabs are stored
* Bugfix: closing a sheet would make all other sheet display the  closed sheets'
 image until drawn on
* Bugfix: Saving a document which has Notes would result in  duplicate notes
  being visible in the Notes tree view.
* Windows exe filesize reduced: 14.2MB -> 4.78MB (!)

----------------------------------------------------------------------

08 Apr 2009 -- 0.36.5

* Bugfix with drawing "outlined" shapes having inverted colours lines when
  drawing over other colours.
* Bugfix with opening new window with Windows EXE
* Bugfix: thumbnails not being drawn white initially on Windows
* Added icon into the EXE

----------------------------------------------------------------------

08 Apr 2009 -- 0.36.4

* Paste image from clipboard into a new sheet
* Toggle full screen view
* Tool panel is now collapsible to give (a little bit) more room in full screen
* Bugfix with eraser cursor in Windows
* Bugfix with Windows not drawing new lines from text input
* Misc. code improvements
* Performance increase from drawing shape 'fix' added in 0.36.2

----------------------------------------------------------------------

07 Apr 2009 -- 0.36.3

* Tooltips for each item on the toolbox
* "New Window" menu item to launch a new Whyteboard instance.
* Important Windows bugfix: .wtbd drawings being "overwritten" on load.
* Important Windows bugfix: .wtbd drawings not restoring the saved selected tool

----------------------------------------------------------------------

05 Apr 2009 -- 0.36.2

* Paste image support. Pasted images will be saved to a temporary directory;
  duplicated pasted images will be saved in one file.
* Copy selection as bitmap with new tool: RectSelect
* Popup menu on the sheet bar. Added "rename" option for sheets, which are saved
  into a save file. Can also close a sheet, open a new sheet or export the
  selected one from the menu
* Cleaner code for managing UI button enabling/disabling
* Bugfix: Editing a note and pressing backspace updates the note properly
* Bugfix: drawing outlined shapes weirdness outside the default scrollbar region
  (introduced in 0.35.8)
* Bugfix: exporting image saves whole sheet, not just the visible area
* Bugfix: Adding a line sometimes wasn't being actually added

----------------------------------------------------------------------

02 Apr 2009 -- 0.36.1

* Fixed an issue with 'flickering' on Windows
* Bugfix: "edit" right-click popup menu on the Note root node.
* Preview for the eyedrop (just shows current colour)

----------------------------------------------------------------------

30 Mar 2009 -- 0.36.0

* Windows UI improvement: change the thickness by scrolling the mousewheel on
  the drop-down box, no need to click it. (this is the default behaviour under
  GNOME)
* Next/Previous sheet in the "Sheets" menu (which previously was "Image") -
  Ctrl+Tab / Ctrl-Shift+Tab shortcut keys
* Side panel is now "collapsible" instead of a "toggle" menu item
* Menus renamed, organised differently
* Popup context menu on Notes tree: Edit (note), Switch To (sheet)
* Text/notes appear on the canvas as you type
* Eraser has a custom rectangle cursor, depending on its size
* Escape button exits "History" dialog
* Updated "About" menu
* Bugfix: can no longer add a blank text/note object

----------------------------------------------------------------------

25 Mar 2009 -- 0.35.9

* Misc. UI improvements: more labels/small grid of drawing colours
* Added eraser tool
* Flood fill temporarily removed, was too buggy
* Tabs renamed to Sheets
* Import -> PDF/PS/Image menu items (as well as through Open)

----------------------------------------------------------------------

20 Mar 2009 -- 0.35.8

* Windows bugfix: outlined shapes not drawing properly
* Windows bugfix: wxPython errors on closing the application with loaded images
* Bugfix with the eyedropper not updating the colour label.

----------------------------------------------------------------------

18 Mar 2009 -- 0.35.7

* Bugfix: toggling side panel on/off caused a lot of lag, should only be
  noticeable now with around 65+ tabs open.
* Drag and drop support: drop any file that Whyteboard supports into the
  drawing panel to load it
* Hold down the middle mouse button to scroll (was the right btn)

----------------------------------------------------------------------

18 Mar 2009 -- 0.35.6

* Improved undo/redo functionality. It is now possible to undo and redo the clear
  all drawings/clear all tabs' drawings functionality
* Redo is also fixed to more like other applications now: when you undo twice
  and then draw a new shape, your redo history is lost. Before you could redo
  the two undone shapes after the new drawing
* The ImageMagick folder locator will only pop-up when trying to convert a file
  and when the directory is not set, not at application start-up

----------------------------------------------------------------------

17 Mar 2009 -- 0.35.5

* Added dragging around Whyteboard by holding down the right button and moving
  the mouse

----------------------------------------------------------------------

15 Mar 2009 -- 0.35.4

* Big bugfix on Windows: ImageMagick's convert program not being found.
  Whyteboard prompts for its installed location and remembers it. (will also
  notify Linux users if ImageMagick isn't installed)

----------------------------------------------------------------------

11 Mar 2009 -- 0.35.3

* Bugfix: thumbnails getting cut off with too many tabs
* Can load in a file from the commmand line when running Whyteboard

----------------------------------------------------------------------

10 Mar 2009 -- 0.35.2

* Bugfix: Can no longer cancel file load progress dialogs.
* Performance increase: loading large .wtbd files
* Notification of "updating thumbnails" after load/converting a file

----------------------------------------------------------------------

09 Mar 2009 -- 0.35.1

* Bugfix: thumbnails not updating on file load

----------------------------------------------------------------------

08 Mar 2009 -- 0.35.0

* Bugfix: a thumbnail's text label not being removed when the thumbnail was
  removed.

* Side panel is now tabbed to select between thumbnails and a "tree" view of all
  Notes (new feature) for each tab.

Notes are similar to how text is input, except a light yellow background is
drawn around it to indicate it's a note. In the tree control, a note item can
be double clicked upon to bring up the text input dialog to change a note's text


----------------------------------------------------------------------

04 Mar 2009 -- 0.34.6

* Bugfix under Windows: toggling thumbnails would cause an error.

----------------------------------------------------------------------

22 Feb 2009 -- 0.34.5

* Bugfix with drawing 'outlined' shapes. Began work on text 'notes'.
* F5 will refresh all thumbnails since they're not refreshed upon loading a save,
  PDF or PostScript file.

----------------------------------------------------------------------

21 Feb 2009 -- 0.34.0

* Export current tab's view as an image.
* Live thumbnails, get updated when the selected tab is drawn upon
* Thumbnail panel toggleable on/off
* Drawing Preview window now shows a preview of the actual shape instead of
  always showing a line.

----------------------------------------------------------------------

21 Feb 2009 -- 0.33.0

* Text input overhaul, before the text was rendered as a wxPython  widget - now
  it's a drawing of a String, with a custom dialog for inputting the text and
  selecting a font. This new method fixes many problems with having the text as
  widget, such as text being un-undoable and drawings not overwriting the text

* Long text updates the scrollbars, vertically or horizontally
* Program maximises on startup.
* History improvements: draw all shapes back in the correct order
* Save files store the version number; loading an older save file into a newer
  Whteboard version which has added save data will say the older save file's
  version
    ...only problem with that is that the previous version's savefile
       versions aren't known since only know they're being stored

----------------------------------------------------------------------

20 Feb 2009 -- 0.32.6

* Small fix of a silly bug introduced below on accident where a pen would not
  render in its selected colour/thickness.

----------------------------------------------------------------------

19 Feb 2009 -- 0.32.5

* Added GPL.txt + fixed a bug with multiple images loaded into one  tab.
* Fixed 'sure you want to open this file?' message dialog so that it only
  appears if you're loading in a Whyteboard file, not a PDF or PNG, for instance
* Fixed a bug on Windows involving rectangles/circles, yet another persists.

----------------------------------------------------------------------

14 Feb 2009 -- 0.32.0

* Added line drawing tool.
* "Sure you want to quit?" dialog when user hasn't saved.
* Only allowing one .wtbd file to be loaded at once
* Last Selected tab is stored in the .wtdb file
* Undo/redo tool/menu bar items are disabled/enabled as appropriate

----------------------------------------------------------------------

12 Feb 2009 -- 0.31.0

* Fixed saving/loading text controls, scrollbars adjust to screen resolution on
resize.
* Fixed undo/redo visual & clear/clear all. Change clear/clear all to 4 options

        * remove all drawings from current tab, keeping images
        * from all from current tab
        * remove all drawings from all tabs, keeping images
        * clear all tabs

----------------------------------------------------------------------

12 Feb 2009 -- 0.30.0

* Scrolling works properly. Loading an image will expand the scroll bars to the
  image size if the image is too big. Improvements to the history replaying,
  rewrote most of the drawing code again.

----------------------------------------------------------------------

11 Feb 2009 -- 0.29.0

* Saving/loading working. Currently keeping tmp files from PDF/PS conversions to
  make loading a saved file faster (would need to convert any 'linked' PDF/PS
  files for every .wtdb load) Saving text works, program also saves its settings

----------------------------------------------------------------------

11 Feb 2009 -- 0.28.0

* Fixed history replaying, added pause/ stop the replay.
* Fixed a bug with the converting progress where the bar increased in response
mouse movement - now it's increased by a timer.

----------------------------------------------------------------------

10 Feb 2009 -- 0.27.0

* Converting PDF/PS pops up a "converting" progress bar

----------------------------------------------------------------------

10 Feb 2009 -- 0.26.0

* More code unification, cleaner code, deleting tmp files, loading multiple
PDF/PS/SVG files

----------------------------------------------------------------------

09 Feb 2009 -- 0.25.0

* Code refactored, performance increased ten-fold, some bug fixes

----------------------------------------------------------------------

03 Feb 2009 -- 0.20.5

* Minor code cleanup

----------------------------------------------------------------------

02 Feb 2009 -- 0.20.0

* Added a toolbar, each whyteboard tab has its own undo/redo history

----------------------------------------------------------------------

31 Jan 2009 -- 0.15.0

* Closing the program removes temporary PNG files from PDF convert

----------------------------------------------------------------------

I wish I kept a longer version history.